//
//  cvmat_serialization.h
//  FeatureDetector
//
//  Created by 熊田 聖也 on 12/05/07.
//  Copyright (c) 2012年 __MyCompanyName__. All rights reserved.
//

#ifndef FeatureDetector_cvmat_serialization_h
#define FeatureDetector_cvmat_serialization_h


// file: cvmat_serilization.h
// http://stackoverflow.com/questions/4170745/serializing-opencv-mat-vec3f
// http://cheind.wordpress.com/2011/12/06/serialization-of-cvmat-objects-using-boost/


#include <opencv2/opencv.hpp>
#include <boost/serialization/split_free.hpp>
#include <boost/serialization/vector.hpp>

BOOST_SERIALIZATION_SPLIT_FREE(::cv::Mat)
namespace boost {
  namespace serialization {

    /** Serialization support for cv::Mat */
    template<typename Archive>
    void save(Archive & ar, const ::cv::Mat& m, const unsigned int version)
    {
      size_t elem_size = m.elemSize();
      size_t elem_type = m.type();

      ar & m.cols;
      ar & m.rows;
      ar & elem_size;
      ar & elem_type;

      const size_t data_size = m.cols * m.rows * elem_size;
      ar & boost::serialization::make_array(m.ptr(), data_size);
    }

    /** Serialization support for cv::Mat */
    template<typename Archive>
    void load(Archive & ar, ::cv::Mat& m, const unsigned int version)
    {
      int cols, rows;
      size_t elem_size, elem_type;

      ar & cols;
      ar & rows;
      ar & elem_size;
      ar & elem_type;

      m.create(rows, cols, elem_type);

      size_t data_size = m.cols * m.rows * elem_size;
      ar & boost::serialization::make_array(m.ptr(), data_size);
    }

  }
}

void save_mat(const cv::Mat& m, const std::string& filename);
void load_mat(cv::Mat& m, const std::string& filename);


#endif
